package com.lantone.qc.kernel.catalogue.firstpagerecord;

import com.lantone.qc.kernel.catalogue.QCCatalogue;
import com.lantone.qc.kernel.util.CatalogueUtil;
import com.lantone.qc.pub.Content;
import com.lantone.qc.pub.model.InputInfo;
import com.lantone.qc.pub.model.OutputInfo;
import com.lantone.qc.pub.model.doc.RescueDoc;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @ClassName : FIRP0250
 * @Description : 抢救成功次数填写错误
 * @Author : 楼辉荣
 * @Date: 2020-03-06 17:28ss
 */
@Component
public class FIRP0250 extends QCCatalogue {
    public void start(InputInfo inputInfo, OutputInfo outputInfo) {
        status.set("0");
        if (inputInfo.getFirstPageRecordDoc() != null && inputInfo.getFirstPageRecordDoc().getStructureMap() != null) {
            Map<String, String> firstpageStructureMap = inputInfo.getFirstPageRecordDoc().getStructureMap();
            String name = firstpageStructureMap.get(Content.rescue_condition);
            if (!CatalogueUtil.isEmpty(name)){
                String[] split = name.split("\\s+");
                Pattern compile = Pattern.compile("(?<=成功).*(?=次)");
                Matcher matcher = compile.matcher(split[0]);
                while (matcher.find()){
                    try{
                        String number = matcher.group(0);
                        int i = 0;
                        List<RescueDoc> rescueDocs = inputInfo.getRescueDocs();
                        if(rescueDocs != null && rescueDocs.size()>0){
                            for (RescueDoc re:rescueDocs
                                 ) {
                                Map<String, String> structureMap = re.getStructureMap();
                                String qjgc = structureMap.get("抢救过程");
                                if(!qjgc.contains("死亡")){
                                    i++;
                                }
                            }

                            try{
                                int num = Integer.parseInt(number);
                                if(num != i){
                                    status.set("-1");
                                }
                            }catch (Exception e){
                                e.printStackTrace();
                            }

                        }
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }


            }
        }
    }
}